#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <ctype.h>
#include <math.h>

int p,m,K,boundl,boundp;
double lambda_com;

typedef struct task{
  int Place;
  int Cost;
  int Input;
  int Output;
} task;

typedef struct proc{
    int Speed;
    double Lambda;
} proc;

void values();

struct task *chain;
struct proc *processors;

int main(){
  int i,j,k,l,line=0;
  int sum;
  double rel;
  values();
  printf("Minimize\n");
  printf("  obj: rel\n");
  printf("Subject To\n");
  printf("  row%d: lat ",line);
  for(i=0;i<m;i++){
    for(j=i;j<m;j++){
      sum=0;
      sum=chain[i].Input;
      for(k=i;k<=j;k++){
        sum+=chain[k].Cost;
      }
      for(l=1;l<=K;l++){
        printf("- %d a%d,%d,%d",sum,i,j,l);
      }
    }
  }
  printf("=0\n");
  line++;
  for(i=0;i<m;i++){
    for(j=i;j<m;j++){
      sum=0;
      for(k=i;k<=j;k++){
        sum+=chain[k].Cost;
      }
      for(l=1;l<=K;l++){
        printf("  row%d: per - %d a%d,%d,%d>=0\n",line,sum,i,j,l);
        line++;
        printf("  row%d: per - %d a%d,%d,%d>=0\n",line,chain[i].Input,i,j,l);
        line++;
        printf("  row%d: per - %d a%d,%d,%d>=0\n",line,chain[j].Output,i,j,l);
        line++;
      }
    }
  }
  line++;
  for(i=0;i<m;i++){
    printf("  row%d: ",line);
    line++;
    for(k=0;k<=i;k++){
      for(j=i;j<m;j++){
        for(l=1;l<=K;l++){
          printf("+ a%d,%d,%d",k,j,l);
        }
      }
    }
    printf("=1\n");
  }
  printf("  row%d: -rel",line);
  for(i=0;i<m;i++){
    for(j=i;j<m;j++){
      sum=0;
      for(k=i;k<=j;k++){
        sum+=chain[k].Cost;
      }
      for(l=1;l<=K;l++){
      rel=log(1-pow(1-exp(-processors[0].Lambda*sum)*exp(-lambda_com*((chain[i]).Input+(chain[j]).Output)),l));
      printf("+ %lf a%d,%d,%d",fabs(rel),i,j,l); 
      }
    }
  }
  printf("=0\n");
  line++;
  printf("  row%d: ",line);
  for(i=0;i<m;i++){
    for(j=i;j<m;j++){
      for(l=1;l<=K;l++){
        printf("+ %d a%d,%d,%d",l,i,j,l);
      }
    }
  }
  printf("<=%d\n",p);
  line++;
  printf("Bounds\n");
  printf("lat<=%d\n",boundl);
  printf("per<=%d\n",boundp);
  for(i=0;i<m;i++){
    for(j=i;j<m;j++){
      for(k=1;k<=K;k++){
        printf("0<=a%d,%d,%d<=1\n",i,j,k);
      }
    }
  }
  printf("Binary\n");
  for(i=0;i<m;i++){
    for(j=i;j<m;j++){
      for(k=1;k<=K;k++){
        printf("a%d,%d,%d\n",i,j,k);
      }
    }
  }
  printf("End\n");
  free(processors);
  free(chain);
  return (0);
}

void values(){
  int i,line;
  FILE *fp;
  int val;
  double val2;
  fp = fopen("instances","r");
  fseek(fp,0,SEEK_SET);
  if(fscanf(fp,"%d",&p)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%d",&m)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%d",&K)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%lf",&lambda_com)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%d",&boundl)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%d",&boundp)==EOF){printf("EOF\n");}
  fclose(fp);
  fp = fopen("variables","r");
  fseek(fp,0,SEEK_SET);
  if(fscanf(fp,"%d",&line)==EOF){printf("EOF\n");}
  fseek(fp,0,SEEK_SET);
  processors=malloc(p*sizeof(struct proc));
  chain=malloc(m*sizeof(struct task));
    if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
  (processors[0]).Speed=val;
  if(fscanf(fp,"%lf",&val2)==EOF){printf("EOF\n");}
  (processors[0]).Lambda=val2;
  for (i=1;i<p;i++){
    if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
    (processors[i]).Speed=val;
   if(fscanf(fp,"%lf",&val2)==EOF){printf("EOF\n");}
   (processors[i]).Lambda=val2;
  }
  (chain[0]).Place=0;
    if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
  (chain[0]).Cost=val;
    if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
  (chain[0]).Input=val;
  for (i=1;i<m;i++){
    (chain[i]).Place=i;
      if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
    (chain[i]).Cost=val;
      if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
    (chain[i]).Input=val;
    (chain[i-1]).Output=val;
  }
  (chain[m-1]).Output=0;
  fclose(fp);
}
