#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <ctype.h>
#include <math.h>

int p,m,K,boundp; /*number of processors and tasks*/
double lambda_com;

typedef struct task{
   int Place;
   int Cost;
   int Input;
   int Output;
} task;

typedef struct proc{
  int Speed;
  double Lambda;
  double Ratio;
} proc;

typedef struct interval{
  int Place;
  int Cost;
  int Output;
  int Input;
  int N_proc;
  double Reliability;
} interval;

typedef struct couple{
  int First;
  int Cost;
} couple;

struct task *chain;
struct proc *processors;
struct interval *schedule;

void values();/*to fill previous vertices*/
static int ordre_i(const void *, const void *);
static int ordre_c(const void *, const void *);
static int ordre_s(const void *, const void *);
static int ordre_p(const void *, const void *);
static int ordre_proc(const void *, const void *);

void sched(int);

int main(){
  values();/*initiation of values*/
  int i=0,j=0,k=0,l=0, max_int=p;
  struct task *com_order;
  com_order=malloc(m * sizeof(struct task));
  struct interval init;
  int lat=0, per=0, current_sum=0, val_max=0;
  double rel=1;
  /*minimization of latency*/
  for(i=1;i<m;i++){
    com_order[i-1]=chain[i];}
  if (m<p){max_int=m;}
  qsort(com_order,m-1,sizeof(struct task),ordre_i);
  schedule=malloc(max_int * sizeof(struct interval));
  for(i=1;i<=max_int;i++){
    for(j=0;j<i;j++){
      init.Place=0;
      init.Input=0;
      init.Output=0;
      init.Cost=0;
      init.N_proc=0;
      init.Reliability=1;
      schedule[j]=init;
    }
    lat=0;per=0;rel=1;
    qsort(com_order,i-1,sizeof(struct task),ordre_p);
    k=0;
    for(j=0;j<i;j++){
      (schedule[j]).Place=j;
      (schedule[j]).Input=(chain[k]).Input;
      while(k<m&&(j==i-1||(k<((com_order[j]).Place)))){
        (schedule[j]).Cost+=(chain[k]).Cost;
        k++;
      }
      (schedule[j]).Output=(chain[k-1]).Output;
    }
    sched(i);
    if(schedule[0].Reliability==-1)
    {
      printf("-1 -1 -1\n");
    }
    else{
      per=0;lat=0;rel=1;
      for (j=0;j<i;j++){
        lat+=(schedule[j]).Cost+(schedule[j]).Input;
        if(per<(schedule[j]).Cost){per=(schedule[j]).Cost;}
        if(per<(schedule[j]).Input){per=(schedule[j]).Input;}
        rel*=(schedule[j]).Reliability;
      }
      printf("%d %d %lf\n",per,lat,rel);
    }
  }
  /*minimization of period and reliability*/
  for(i=1;i<=max_int;i++){
    for(j=0;j<i;j++){
      init.Place=0;
      init.Input=0;
      init.Output=0;
      init.Cost=0;
      init.N_proc=0;
      init.Reliability=1;
      schedule[j]=init;
    }
    struct couple tab[m][i];
    for(j=0;j<m;j++){for(k=0;k<i;k++){(tab[j][k]).Cost=-1;(tab[j][k]).First=0;}}
    current_sum=0;
    //first interval
    for(j=0;j<m;j++){
      current_sum+=(chain[j]).Cost;
      if (current_sum>(chain[j]).Output){
        (tab[j][0]).Cost=current_sum;}
      else{(tab[j][0]).Cost=(chain[j]).Output;}
      (tab[j][0]).First=0;
    }
    for(k=1;k<i;k++){//k+1 intervals
      for(j=k;j<m;j++){
        current_sum=0;
        for(l=j;l>=k;l--){
          current_sum+=(chain[l]).Cost;
          val_max=current_sum;
          if(val_max<(chain[j]).Output){
            val_max=(chain[j]).Output;}
          if(val_max<(tab[l-1][k-1]).Cost){val_max=(tab[l-1][k-1]).Cost;}
          if(val_max<(tab[j][k]).Cost||(tab[j][k]).Cost<0){
            (tab[j][k]).Cost=val_max;
            (tab[j][k]).First=l;
          }
        }
      }
    }
    l=m-1;
    for(j=i-1;j>=0;j--){
      current_sum=0;
      for(k=(tab[l][j]).First;k<=l;k++){
        current_sum+=(chain[k]).Cost;
      }
      (schedule[j]).Place=j;
      (schedule[j]).Cost=current_sum;
      (schedule[j]).Output=(chain[l]).Output;
      (schedule[j]).Input=chain[(tab[l][j]).First].Input;
      l=(tab[l][j]).First-1;
      
    }
    sched(i);
    if(schedule[0].Reliability==-1)
    {
      printf("-1 -1 -1\n");
    } 
    else{
      per=0;lat=0;rel=1;
      for(j=0;j<i;j++)
      {
        lat+=(schedule[j]).Cost+(schedule[j]).Input;
        if(per<(schedule[j]).Cost){per=(schedule[j]).Cost;}
        if(per<(schedule[j]).Input){per=(schedule[j]).Input;}
        rel*=(schedule[j]).Reliability;
      }
      printf("%d %d %lf\n",per,lat,rel);
    }
  }
  free(schedule);
  free(processors);
  free(chain);
  free(com_order);
  return(0);
}



void values(){
  int i,line;
  FILE *fp;
  int val;
  double val2;
  fp = fopen("instances","r");
  fseek(fp,0,SEEK_SET);
  if(fscanf(fp,"%d",&p)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%d",&m)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%d",&K)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%lf",&lambda_com)==EOF){printf("EOF\n");}
    if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
  if(fscanf(fp,"%d",&boundp)==EOF){printf("EOF\n");}
  fclose(fp);
  fp = fopen("variables","r");
  fseek(fp,0,SEEK_SET);
  if(fscanf(fp,"%d",&line)==EOF){printf("EOF\n");}
  fseek(fp,0,SEEK_SET);
  processors=malloc(p*sizeof(struct proc));
  chain=malloc(m*sizeof(struct task));
  if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
  (processors[0]).Speed=val;
  if(fscanf(fp,"%lf",&val2)==EOF){printf("EOF\n");}
  (processors[0]).Lambda=val2;
  (processors[0]).Ratio=((processors[0]).Lambda)/((double)(processors[0]).Speed);
  for (i=1;i<p;i++){
    if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
    (processors[i]).Speed=val;
    if(fscanf(fp,"%lf",&val2)==EOF){printf("EOF\n");}
    (processors[i]).Lambda=val2;
    (processors[i]).Ratio=((processors[i]).Lambda)/((double)(processors[i]).Speed);
  }
  (chain[0]).Place=0;
  if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
  (chain[0]).Cost=val;
  if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
  (chain[0]).Input=val;
  for (i=1;i<m;i++){
    (chain[i]).Place=i;
    if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
    (chain[i]).Cost=val;
    if(fscanf(fp,"%d",&val)==EOF){printf("EOF\n");}
    (chain[i]).Input=val;
    (chain[i-1]).Output=val;
  }
  (chain[m-1]).Output=0;
  fclose(fp);
}

void sched(int n_int){/*give processors to intervals*/
  int k=0, j=0, n_full=0, lim_int,l;// lowest=(processors[0]).Speed;
  int possible, current_proc;
  int *n;
  double ratio, current_rel, rel;
  struct proc *remaining;
  n=malloc(n_int*sizeof(int));
  remaining=malloc(p*sizeof(struct proc));
  for (k=0;k<p;k++){remaining[k]=processors[k];}
  qsort(processors,p,sizeof(struct proc),ordre_s);
  qsort(schedule,n_int,sizeof(struct interval),ordre_c);
  j=0;
  while(j<p&&((double)schedule[n_int-1].Cost)/((double)processors[p-j-1].Speed)<(double)boundp){j++;}
  n[n_int-1]=j-1;
  for(k=1;k<n_int;k++){
    n[n_int-k-1]=n[n_int-k]-1;
    while(j<p&&((double)schedule[n_int-k].Cost)/((double)processors[p-j-1].Speed)<boundp)
    {j++;n[n_int-k-1]++;}
  }
  possible=1;
  for(k=0;k<n_int;k++){if(n[k]<0){possible=0;}}
  if(possible==0){schedule[0].Reliability=-1;}
  else{
    qsort(processors,p,sizeof(struct proc),ordre_proc);
    qsort(schedule,n_int,sizeof(struct interval),ordre_c);
    //initialization
    l=0;
    for(k=0;k<p;k++){
      j=0;
      while(j<n_int&&((double)schedule[j].Cost)/((double)processors[k].Speed)<boundp){j++;}
      j--;
      if(j>=0){
        while(j>=0&&schedule[j].N_proc>0){j--;}
        if(j>=0){schedule[j].Reliability=exp(-((double)processors[k].Lambda)/((double)processors[k].Speed)*(schedule[j]).Cost)*exp(-lambda_com*((schedule[j]).Input+(schedule[j]).Output));
          (schedule[j]).N_proc++;
        }
        else{remaining[l]=processors[k];l++;}
      }
    }
    //allocation
    if(K>1){
      k=0;
      while(k<l&&n_full<n_int){
        j=0;
        while(j<n_int&&((double)schedule[j].Cost)/((double)remaining[k].Speed)<boundp)
        {j++;}
        lim_int=j;
        j--;
        ratio=0;current_proc=-1;
        for(j=0;j<lim_int;j++){
          rel=1-(1-schedule[j].Reliability)*(1-exp(-(remaining[k]).Ratio*(schedule[j]).Cost)*exp(-lambda_com*((schedule[j]).Input+(schedule[j]).Output)));
          if(rel/(schedule[j].Reliability)>ratio&&(schedule[j].N_proc<K)){current_proc=j;ratio=rel/(schedule[j].Reliability);current_rel=rel;}
        }
        if(current_proc>=0){
          schedule[current_proc].N_proc++;
          schedule[current_proc].Reliability=current_rel;
          if((schedule[current_proc]).N_proc==K){n_full++;}
        }
        k++;
      }
    }
  }
  free(remaining);
  free(n);
}

static int ordre_i(const void *c1, const void *c2){
  if((*(struct task *)c1).Input<(*(struct task *)c2).Input){return(-1);}
  if((*(struct task *)c1).Input>(*(struct task *)c2).Input){return(1);}
  return(0);
}

static int ordre_p(const void *c1, const void *c2){
  if((*(struct task *)c1).Place<(*(struct task *)c2).Place){return(-1);}
  if((*(struct task *)c1).Place>(*(struct task *)c2).Place){return(1);}
  return(0);
}

static int ordre_c(const void *c1, const void *c2){
  if((*(struct interval *)c1).Cost<(*(struct interval *)c2).Cost){return(-1);}
  if((*(struct interval *)c1).Cost>(*(struct interval *)c2).Cost){return(1);}
  return(0);
}

static int ordre_proc(const void *c1, const void *c2){
  if((*(struct proc *)c1).Ratio<(*(struct proc *)c2).Ratio){return(-1);}
  if((*(struct proc *)c1).Ratio>(*(struct proc *)c2).Ratio){return(1);}
  return(0);
}


static int ordre_s(const void *c1, const void *c2){
  if((*(struct proc *)c1).Speed<(*(struct proc *)c2).Speed){return(-1);}
  if((*(struct proc *)c1).Speed>(*(struct proc *)c2).Speed){return(1);}
  return(0);
}
